{-# LANGUAGE MultiParamTypeClasses #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
module System.Process.Text where

import Control.Exception
import Control.Monad
import Data.Text (Text)
import Data.ListLike (null)
import Data.ListLike.IO (hGetContents, hPutStr)
import Prelude hiding (null)
import System.Process
import qualified System.Process.ListLike as LL
import System.Exit (ExitCode)
import System.IO (hClose, hFlush)
import Utils (forkWait)

-- | Like 'System.Process.readProcessWithExitCode', but using 'Text'
instance LL.ListLikeProcessIO Text Char where
    forceOutput = return

-- | Specialized version for backwards compatibility.
readProcessWithExitCode :: FilePath -> [String] -> Text -> IO (ExitCode, Text, Text)
readProcessWithExitCode = LL.readProcessWithExitCode

readCreateProcessWithExitCode :: CreateProcess -> Text -> IO (ExitCode, Text, Text)
readCreateProcessWithExitCode = LL.readCreateProcessWithExitCode
